﻿;==============================================================================================================================================================================
; Send messages and error reports to the fake status bar area
;==============================================================================================================================================================================

Procedure SetInfoBarArea(FieldName.s, FieldStatus.s, MessageContent.s = "0", ModuleName.s = "")
  
  ;------------------------------------------------------------------------------------------------
  ; Select the name of the field to put our heading string
  ;------------------------------------------------------------------------------------------------
  
  Select FieldName.s
      
    ;----------------------------------------------------------------------------------------------
    ; Select the correct heading by the status field
    ;----------------------------------------------------------------------------------------------
    
    Case "Headings"
    
      ;--------------------------------------------------------------------------------------------
      ; This is the field status heading and message
      ;--------------------------------------------------------------------------------------------
      
      Select FieldStatus.s
          
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
          
        Case "Welcome"
          
          MessageHeader.s = "Welcome"
          
          SetGadgetText(#Gadget_RashadBin_sHeading,      MessageHeader.s + ">>")
    
          SetGadgetText(#Gadget_RashadBin_sMessages,     MessageContent.s)
          
          SetGadgetColor(#Gadget_RashadBin_sMessages,    #PB_Gadget_FrontColor, $DB3D24)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Case "Blankline"
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          MessageHeader.s = #EmptyString
          
          SetGadgetText(#Gadget_RashadBin_sHeading,      MessageHeader.s)
          
          SetGadgetText(#Gadget_RashadBin_sMessages,     #EmptyString)
          
          SetGadgetColor(#Gadget_RashadBin_sMessages,    #PB_Gadget_FrontColor, $DB3D24)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Case "Button"
          
          MessageHeader.s = "Button tool tip"
          
          Colour.i        = $00008B
          
          SetGadgetText(#Gadget_RashadBin_sHeading,      MessageHeader.s + ">>")
    
          SetGadgetText(#Gadget_RashadBin_sMessages,     MessageContent.s)
          
          SetGadgetColor(#Gadget_RashadBin_sMessages,    #PB_Gadget_FrontColor, Colour.i)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Case "Info"
          
          MessageHeader.s = "Information"
          
          Colour.i        = $DB3D24
          
          SetGadgetText(#Gadget_RashadBin_sHeading,      MessageHeader.s + ">>")
    
          SetGadgetText(#Gadget_RashadBin_sMessages,     MessageContent.s)
          
          SetGadgetColor(#Gadget_RashadBin_sMessages,    #PB_Gadget_FrontColor, Colour.i)
          
          AddGadgetItem(#Gadget_RashadBin_Messagelist,   #AtTheEndOfTheList, MessageHeader.s  + ":  "  + MessageContent.s) 
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Case "Warn"
          
          MessageHeader.s = "Warning"
          
          Colour.i        = $7D1F82
          
          SetGadgetText(#Gadget_RashadBin_sHeading,      MessageHeader.s + ">>")
    
          SetGadgetText(#Gadget_RashadBin_sMessages,     MessageContent.s)
          
          SetGadgetColor(#Gadget_RashadBin_sMessages,    #PB_Gadget_FrontColor, Colour.i)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Case "Error"
          
          MessageHeader.s = "Error"
          
          Colour.i        = $0402FB
          
          AddGadgetItem(#Gadget_RashadBin_Errorlist, #AtTheEndOfTheList, MessageHeader.s  + #LF$  + MessageContent.s  + #LF$  + ModuleName.s)
          
      EndSelect
      
      ;--------------------------------------------------------------------------------------------
      ; This is the current record number field
      ;--------------------------------------------------------------------------------------------

    Case "Resources"
      
      ;--------------------------------------------------------------------------------------------
      ; Figure out the correct spelling for the record field for singles or multiples
      ;--------------------------------------------------------------------------------------------
      
      If Val(MessageContent.s) = 0
        
        RecordHeader.s = "Resources"
        
      ElseIf Val(MessageContent.s)  = 1
        
        RecordHeader.s = "Resource"
        
      ElseIf Val(MessageContent.s) > = 2
        
        RecordHeader.s = "Resources"
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; Set the record number details in the fake status bar area
      ;--------------------------------------------------------------------------------------------
      
      SetGadgetText(#Gadget_RashadBin_sResources, MessageContent.s + " " + RecordHeader.s)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Case "Images"
      
      ;--------------------------------------------------------------------------------------------
      ; Figure out the correct spelling for the record field for singles or multiples
      ;--------------------------------------------------------------------------------------------
      
      If Val(MessageContent.s) = 0
        
        RecordHeader.s = "Images"
        
      ElseIf Val(MessageContent.s)  = 1
        
        RecordHeader.s = "Image"
        
      ElseIf Val(MessageContent.s) > = 2
        
        RecordHeader.s = "Images"
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; Set the record number details in the fake status bar area
      ;--------------------------------------------------------------------------------------------
      
      SetGadgetText(#Gadget_RashadBin_sRecords, MessageContent.s + " " + RecordHeader.s)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.61 (Windows - x86)
; CursorPosition = 166
; FirstLine = 139
; Folding = -
; EnableAsm
; EnableXP