﻿;==========================================================================================================================================================
; Write all selected resources to the PB DataSection file
;==========================================================================================================================================================

Procedure SaveToCurrentDatasectionFile()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CurrentDataSectionFileName.s = GetGadgetText(#Gadget_RashadBin_sCurrentdatafile)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If CurrentDataSectionFileName.s <> #EmptyString                                                     
    
    ;---------------------------------------------------------------------------------------------- 
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SetInfoBarArea("Headings",  "Info",  "Data section file name:  " + CurrentDataSectionFileName.s, #PB_Compiler_Procedure)
    
    ;----------------------------------------------------------------------------------------------
    ; Create the new file with full path and correct extension
    ;----------------------------------------------------------------------------------------------
    
    CurrentDataSectionFileHandle.i = CreateFile(#PB_Any, Program\SavedIncludesDirectory.s + CurrentDataSectionFileName.s)
    
    ;---------------------------------------------------------------------------------------------- 
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SetInfoBarArea("Headings",  "Info",  Program\SavedIncludesDirectory.s + CurrentDataSectionFileName.s, #PB_Compiler_Procedure)
    
    ;---------------------------------------------------------------------------------------------- 
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If IsFile(CurrentDataSectionFileHandle.i)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If CurrentDataSectionFileHandle.i <> #NoFileHandle                                              
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        SetInfoBarArea("Headings",  "Info",  "Data section file handle:  "  + Str(CurrentDataSectionFileHandle.i), #PB_Compiler_Procedure)
        
        ;------------------------------------------------------------------------------------------
        ; This is where RASHAD's magic file write code will go
        ;------------------------------------------------------------------------------------------
        
        NumberOfFiles.i           = CountGadgetItems(#Gadget_RashadBin_FileList)                      
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        SetInfoBarArea("Headings",  "Info",  "Number of files to process:  " + Str(NumberOfFiles.i), #PB_Compiler_Procedure)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        NumberOfColumnsToWrite.i  = Val(GetGadgetText(#Gadget_RashadBin_sColumnsPerLine))             
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        SetInfoBarArea("Headings",  "Info",  "Number of columns to write:  " + Str(NumberOfColumnsToWrite.i), #PB_Compiler_Procedure)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If NumberOfFiles.i <> #False
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          WriteStringN(CurrentDataSectionFileHandle.i, "DataSection")                                 
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          SetInfoBarArea("Headings",  "Info",  "DataSection heading written", #PB_Compiler_Procedure)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          WriteStringN(CurrentDataSectionFileHandle.i, #EmptyString)                                  
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          SetInfoBarArea("Headings",  "Info",  "Blank string written", #PB_Compiler_Procedure)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          For StartHexing.i = 0 To NumberOfFiles.i -1                                      
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            SetInfoBarArea("Headings",  "Info",  "Writing file: " + Str(StartHexing.i)  + " of: "  + Str(NumberOfFiles.i), #PB_Compiler_Procedure)
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            If GetGadgetItemState(#Gadget_RashadBin_FileList, StartHexing.i) & (#PB_ListIcon_Checked | #PB_ListIcon_Selected)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              CurrentFileName.s = GetGadgetItemText(#Gadget_RashadBin_FileList, StartHexing.i, 0)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              SetInfoBarArea("Headings",  "Info",  CurrentFileName.s, #PB_Compiler_Procedure)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              CurrentFileType.s = GetGadgetItemText(#Gadget_RashadBin_FileList, StartHexing.i, 1)       
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              SetInfoBarArea("Headings",  "Info",  CurrentFileType.s, #PB_Compiler_Procedure)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              CurrentPathName.s = GetGadgetItemText(#Gadget_RashadBin_FileList, StartHexing.i, 2)       
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              SetInfoBarArea("Headings",  "Info",  CurrentPathName.s, #PB_Compiler_Procedure)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              ValidLabel.s = MakeValidName(CurrentFileName.s)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              WriteStringN(CurrentDataSectionFileHandle.i, ValidLabel.s + "_Start:")
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              CurrentDataFile.i = ReadFile(#PB_Any, CurrentPathName.s + CurrentFileName.s)              
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              SetInfoBarArea("Headings",  "Info",  CurrentPathName.s + CurrentFileName.s, #PB_Compiler_Procedure)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              If CurrentDataFile.i  <> #NoFileHandle
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
                Repeat
                  
                  For ProcessColumn.i = 1 To NumberOfColumnsToWrite.i
                    
                    For ItemsPerColumn.i = 1 To 8
                      
                      If Eof(CurrentDataFile.i)
                        
                        Break
                        
                      Else               
                        
                        ReturnValue.s = RSet(Hex(ReadByte(CurrentDataFile.i), #PB_Byte), 2, "0") + ReturnValue.s
                        
                      EndIf
                      
                    Next ItemsPerColumn.i
                    
                    If ProcessColumn.i = NumberOfColumnsToWrite.i
                      
                      RowText.s = RowText.s  + "$" + ReturnValue.s
                      
                    ElseIf Eof(CurrentDataFile.i)
                      
                      RowText.s = RowText.s + "$" + ReturnValue.s
                      
                      Break
                      
                    Else
                      
                      RowText.s = RowText.s  + "$" + ReturnValue.s + ", "
                      
                    EndIf
                    
                    ReturnValue.s = #EmptyString
                    
                  Next ProcessColumn.i
                  
                  WriteStringN(CurrentDataSectionFileHandle.i, "   Data.q " + RowText.s)
                  
                  RowText.s      = #EmptyString
                  
                  ReturnValue.s  = #EmptyString
                  
                Until Eof(CurrentDataFile.i)
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
                CloseFile(CurrentDataFile.i)
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
                WriteStringN(CurrentDataSectionFileHandle.i, ValidLabel.s + "_End:")
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
                ValidLabel.s  = #EmptyString
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
                SetInfoBarArea("Headings",  "Info",  "End of current resource write reached", #PB_Compiler_Procedure)
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
                WriteStringN(CurrentDataSectionFileHandle.i, #EmptyString)
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
                SetInfoBarArea("Headings",  "Info",  "Blank string written after end of resource write", #PB_Compiler_Procedure)
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
              Else
                
                SetInfoBarArea("Headings",  "Error",  "Could not open the data file to read from", #PB_Compiler_Procedure)
                
              EndIf
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
            Else
              
              SetInfoBarArea("Headings",  "Warn",  "The current item isn't checked so will not be processed", #PB_Compiler_Procedure)
              
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
  
          Next StartHexing.i
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings",  "Warn",  "There are no files selected in the list to be processed", #PB_Compiler_Procedure)
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        SetInfoBarArea("Headings",  "Error",  GetFilePart(CurrentDataSectionFileName.s) + " saved to: " + Program\SavedIncludesDirectory.s, #PB_Compiler_Procedure)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        WriteStringN(CurrentDataSectionFileHandle.i, #EmptyString) 
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        WriteStringN(CurrentDataSectionFileHandle.i, "EndDataSection")
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        CloseFile(CurrentDataSectionFileHandle.i)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings",  "Error",  "Could not create the new datasection file", #PB_Compiler_Procedure)
        
      EndIf
    
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings",  "Error",  "This is not a validly initialised file", #PB_Compiler_Procedure)
      
    EndIf
      
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Error",  "User didn't specify a datasection include file file so we should just stop right now", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.61 (Windows - x86)
; CursorPosition = 172
; FirstLine = 163
; Folding = -
; EnableAsm
; EnableXP
; EnableUnicode