﻿;==============================================================================================================================================================================
; Drop and display the dragged resources onto the resource list
;==============================================================================================================================================================================

Procedure DropOnResourceFileList(DragType.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Macro DisplayDroppedItems(CurrentResourceName, CurrentResourceType, CurrentResourceDirectory)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    ResourceListItems.i = CountGadgetItems(#Gadget_RashadBin_FileList)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    ErrorFlag.i = #False
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    For ResourceListLoop.i = 0 To ResourceListItems.i - 1
      
      CurrentResourceItem.s = GetGadgetItemText(#Gadget_RashadBin_FileList, ResourceListLoop.i, #NameColumn)
      
      If LCase(CurrentResourceItem.s) = LCase(CurrentResourceName.s)
        
        ErrorFlag.i = #True
        
        Break
        
      EndIf
      
    Next  ResourceListLoop.i
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If ErrorFlag.i = #False
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      AddGadgetItem(#Gadget_RashadBin_FileList, #AtTheEndOfTheList, CurrentResourceName.s + #LF$ + CurrentResourceType.s + #LF$ + CurrentResourceDirectory)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SortResourceListEntries()
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      TheLastLineInTheList.i = CountGadgetItems(#Gadget_RashadBin_FileList)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SendMessage_(GadgetID(#Gadget_RashadBin_FileList), #LVM_ENSUREVISIBLE, TheLastLineInTheList.i, #False)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetInfoBarArea("Headings",  "Resources",  Str(TheLastLineInTheList.i), #PB_Compiler_Procedure)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings",  "Info",  CurrentResourceDirectory.s  + CurrentResourceName.s + " is already in the resource list", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  EndMacro
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Select DragType.s
      
    Case "Text"
      
      CurrentResource.s = EventDropText()  
      
      If CurrentResource.s
        
        NumberOfItems = CountString(CurrentResource.s, #LF$)
        
        For ProcessLoop.i = 1 To NumberOfItems
          
          CurrentResourceString.s     = StringField(CurrentResource.s, ProcessLoop.i, #LF$)
          
          CurrentResourceName.s       = StringField(CurrentResourceString.s, 1, "|")
          
          CurrentResourceType.s       = StringField(CurrentResourceString.s, 2, "|")
          
          CurrentResourceDirectory.s  = StringField(CurrentResourceString.s, 3, "|")
          
          DisplayDroppedItems(CurrentResourceName, CurrentResourceType, CurrentResourceDirectory)
          
        Next ProcessLoop
        
      Else
        
        ; No text was dropped from the resource file list
        
      EndIf
      
    Case "Files"
      
      CurrentResource.s           = EventDropFiles()
      
      If CurrentResource.s
        
        NumberOfItems = CountString(CurrentResource.s, #LF$)
        
        For ProcessLoop.i = 1 To NumberOfItems
          
          CurrentResourceString.s     = StringField(CurrentResource.s, ProcessLoop.i,             #LF$)
          
          CurrentResourceName.s       = GetFilePart(StringField(CurrentResourceString.s, 1,       "|"))
          
          CurrentResourceType.s       = GetExtensionPart(StringField(CurrentResourceString.s, 2,  "|"))
          
          CurrentResourceDirectory.s  = GetPathPart(StringField(CurrentResourceString.s, 3,       "|"))
          
          DisplayDroppedItems(CurrentResourceName, CurrentResourceType, CurrentResourceDirectory)
          
        Next ProcessLoop
        
      Else
        
        ; No text was dropped from the resource file list
        
      EndIf
      
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.61 (Windows - x86)
; CursorPosition = 86
; FirstLine = 107
; Folding = -
; EnableAsm
; EnableXP
; EnableUnicode