﻿;================================================================================================================================================================================
; Unicode aware directory creation
;================================================================================================================================================================================

Procedure.s MakeSureDirectoryPathExists(Directory.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected Message.s
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

  ErrorCode.i = SHCreateDirectory(#Null, Directory.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Select ErrorCode.i
      
    Case #ERROR_SUCCESS
      
      ErrorFlag.i  = #False
      
      Message.s = "Directory created"                            ; ResultCode = 0
    
    Case #ERROR_BAD_PATHNAME
      
      ErrorFlag.i  = #True
      
      Message.s = "Bad directory path"                           ; ResultCode = 161
    
    Case #ERROR_FILENAME_EXCED_RANGE
      
      ErrorFlag.i  = #True
      
      Message.s = "Directory path too long"                      ; ResultCode = 206
      
    Case #ERROR_FILE_EXISTS
      
      ErrorFlag.i  = #True
      
      Message.s = "Directory already exists"                     ; ResultCode = 80
    
    Case #ERROR_ALREADY_EXISTS
      
      ErrorFlag.i  = #True
      
      Message.s = "Directory already exists"                     ; ResultCode = 183
    
;     Case #ERROR_CANCELLED
;       
;       ErrorFlag.i  = #True
;       
;       Message.s = "User cancelled creation"                       ; ResultCode = ??. Not defined in compiler residents
    
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  Select  ErrorFlag.i
      
    Case #True
      
      SetInfoBarArea("Headings", "Info", Message.s  + ":  "  + Directory.s, #PB_Compiler_Procedure)
      
    Case #False
      
      SetInfoBarArea("Headings", "Error", Message.s + ":  "  + Directory.s, #PB_Compiler_Procedure)
      
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

  ProcedureReturn Message.s
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ; Debug MakeSureDirectoryPathExists("c:\1\2\3\4\5\6")
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

EndProcedure

  

; IDE Options = PureBasic 5.61 (Windows - x86)
; CursorPosition = 58
; FirstLine = 35
; Folding = -
; EnableAsm
; EnableXP
; EnableUnicode