﻿;==============================================================================================================================================================================
; Manually import resources from disk with a filerequester
;==============================================================================================================================================================================

Procedure ImportResourcesFromDisk()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ImportDirectory.s = PathRequester("Import resources from", #EmptyString)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If ImportDirectory.s  <>  #EmptyString                                                            ;: Debug "Selected import directory: "  + ImportDirectory.s
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Protected DirectoryId.i, TypeOfFile.i, Filename.s
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    DirectoryId.i = ExamineDirectory(#PB_Any, ImportDirectory.s, "*.*")
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If DirectoryId.i
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      Repeat
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        ErrorFlag.i = #False
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        TypeOfFile.i  = NextDirectoryEntry(DirectoryId.i) 
        
        Filename.s    = DirectoryEntryName(DirectoryId.i)                                           ;: Debug "Current filename found:  " + Filename.s
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If TypeOfFile.i <> #False
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          NumberOfItems.i     = CountGadgetItems(#Gadget_RashadBin_FileList)
          
          If NumberOfItems.i  <>  #NoListItems
            
            For CompareLoop.i = 0 To NumberOfItems.i - 1
              
              CompareFileName.s = GetGadgetItemText(#Gadget_RashadBin_FileList, CompareLoop.i, 0) ; : Debug CompareFileName.s
              
              CompareFileType.s = GetGadgetItemText(#Gadget_RashadBin_FileList, CompareLoop.i, 1) ; : Debug CompareFileType.s
              
              ComparePathName.s = GetGadgetItemText(#Gadget_RashadBin_FileList, CompareLoop.i, 2) ; : Debug ComparePathName.s
              
              If ComparePathName.s  + CompareFileName.s = ImportDirectory.s  + Filename.s
                
                ErrorFlag.i = #True
                
                Break
                
              EndIf
              
            Next CompareLoop.i
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          If ErrorFlag.i = #False
            
            Select GetExtensionPart(Filename.s)

              Case "Png", "Jpg", "Tif", "Bmp", "Tga", "Ico"

              AddGadgetItem(#Gadget_RashadBin_FileList, #AtTheEndOfTheList, Filename.s + #LF$ + GetExtensionPart(Filename.s) + #LF$ + ImportDirectory.s)
              
              TheLastLineInTheList.i = CountGadgetItems(#Gadget_RashadBin_FileList)
              
              SendMessage_(GadgetID(#Gadget_RashadBin_FileList), #LVM_ENSUREVISIBLE, TheLastLineInTheList.i, #False)
              
              SetInfoBarArea("Headings",  "Resources",  Str(TheLastLineInTheList.i), #PB_Compiler_Procedure)
              
            EndSelect
          
          Else
            
            SetInfoBarArea("Headings",  "Warn",  ImportDirectory.s  + Filename.s + " is already in the resource list", #PB_Compiler_Procedure)
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings",  "Info",  "No more directory entries to find", #PB_Compiler_Procedure)
          
        EndIf 
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Until TypeOfFile.i = #False
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SortResourceListEntries()

      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings",  "Error",  "No directory id was returned. File system error", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Warn",  "No Import directory name specified for the import", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure
  
; IDE Options = PureBasic 5.61 (Windows - x86)
; CursorPosition = 112
; FirstLine = 107
; Folding = -
; EnableAsm
; EnableXP