﻿;==========================================================================================================================================================
; Load another resource list
;==========================================================================================================================================================

Procedure LoadResourceFileList(Mode.s)
  
  ;------------------------------------------------------------------------------------------------
  ; Ask the user for a new filename
  ;------------------------------------------------------------------------------------------------
  
  If Mode.s = "New"
    
    OldResourceListFile.s = OpenFileRequester("New resource file", Program\ResourceListDirectory.s, "Resource list | *.pbrsc", 0)
    
  Else
    
    If FileSize(Program\ConfigDirectory.s + "LastUsedResourceFile.sem") > 1 ; Not directory Or file
      
      ConfigFileHandle.i = ReadFile(#PB_Any, Program\ConfigDirectory.s + "LastUsedResourceFile.sem")
      
      If ConfigFileHandle.i <> #NoFileHandle
        
        OldResourceListFile.s = ReadString(ConfigFileHandle.i)
        
        CloseFile(ConfigFileHandle.i)
        
      Else
        
        ; Could not read the file tracker
        
      EndIf
      
    Else
      
      OldResourceListFile.s =  Program\ResourceListDirectory.s + "Default resources list.pbrsc"
      
      ; Load default resource file as last used config source does not exist.
      
    EndIf
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Read the old file with full path and correct extension
  ;------------------------------------------------------------------------------------------------
  
  OldResourceList.i = ReadFile(#PB_Any, OldResourceListFile.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If OldResourceList.i <> #NoFileHandle
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SetGadgetText(#Gadget_RashadBin_sCurrentresourcelist, GetFilePart(OldResourceListFile.s))
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    ClearGadgetItems(#Gadget_RashadBin_FileList)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    While Eof(OldResourceList.i) = #NotFileEnd
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      ResourceFileName.s = ReadString(OldResourceList.i)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      CurrentFileName.s = StringField(ResourceFileName.s, 1, "|") ; : Debug CurrentFileName.s
      
      CurrentFileType.s = StringField(ResourceFileName.s, 2, "|") ; : Debug CurrentFileType.s
      
      CurrentPathName.s = StringField(ResourceFileName.s, 3, "|") ; : Debug CurrentPathName.s
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      AddGadgetItem(#Gadget_RashadBin_FileList, #AtTheEndOfTheList, CurrentFileName.s + #LF$ +  CurrentFileType   + #LF$  + CurrentPathName.s)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetInfoBarArea("Headings",  "Resources",  Str(CountGadgetItems(#Gadget_RashadBin_FileList)), #PB_Compiler_Procedure)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Wend
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Warn",  "Could not read the old resource list file", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.61 (Windows - x86)
; CursorPosition = 86
; FirstLine = 51
; Folding = -
; EnableXP