﻿;==========================================================================================================================================================
; Save the current list of resources to disk
;==========================================================================================================================================================

Procedure SaveResourceFileList(Mode.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If Mode.s = "New"
    
    NewResourceListFile.s = SaveFileRequester("New resource file", Program\ResourceListDirectory.s + "Default_resources_list.pbrsc", "Resource list | *.pbrsc", 0)
    
  Else
    
    NewResourceListFile.s = Program\ResourceListDirectory.s + "Default_resources_list.pbrsc"
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Check which extension it was and add it
  ;------------------------------------------------------------------------------------------------
  
  If LCase(GetExtensionPart(NewResourceListFile.s)) <> "pbrsc"
    
    NewResourceListFile.s + ".pbrsc"
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If NewResourceListFile.s <> #EmptyString
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    NumberOfItemsInList.i = CountGadgetItems(#Gadget_RashadBin_FileList)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If NumberOfItemsInList.i <> #NoListItems
      
      ;--------------------------------------------------------------------------------------------
      ; Create the new file with full path and correct extension
      ;--------------------------------------------------------------------------------------------
      
      NewResourceList.i = CreateFile(#PB_Any, NewResourceListFile.s)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If IsFile(NewResourceList.i)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If NewResourceList.i <> #NoFileHandle                                                       
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          SetInfoBarArea("Headings",  "Info",  "Created: " + NewResourceListFile.s + ", Handle:  " + Str(NewResourceList.i), #PB_Compiler_Procedure)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          For ProcessItems.i = NumberOfItemsInList.i -1 To 0 Step -1
            
            CurrentFileName.s = GetGadgetItemText(#Gadget_RashadBin_FileList, ProcessItems.i, 0)
            
            CurrentFileType.s = GetGadgetItemText(#Gadget_RashadBin_FileList, ProcessItems.i, 1)
            
            CurrentPathName.s = GetGadgetItemText(#Gadget_RashadBin_FileList, ProcessItems.i, 2)
            
            Select LCase(CurrentFileType.s)
                
              Case "png", "jpg", "tif", "bmp", "tga", "ico"
                
                WriteStringN(NewResourceList.i, CurrentFileName.s  + "|"  + CurrentFileType.s  + "|" + CurrentPathName.s)
                
            EndSelect
            
          Next ProcessItems.i
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          CloseFile(NewResourceList.i)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings",  "Error",  "Can't create:  "  + GetLastErrorString(GetLastError_()), #PB_Compiler_Procedure)
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings",  "Error",  "Not valid: "  + GetLastErrorString(GetLastError_())  + ", File:  "  + NewResourceListFile.s + ", Handle: "  + Str(NewResourceList), #PB_Compiler_Procedure)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings",  "Error",  "List empty:  "  + GetLastErrorString(GetLastError_()), #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Error",  "No filename: "  + GetLastErrorString(GetLastError_()), #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.61 (Windows - x86)
; CursorPosition = 106
; FirstLine = 100
; Folding = -
; EnableXP