﻿;==============================================================================================================================================================================
; Alphabetically sort the list of resources after it was added to
;==============================================================================================================================================================================

Procedure SortResourceListEntries()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Structure ResourceData
    CurrentResourceName.s
    CurrentResourceType.s
    CurrentResourceDirectory.s
  EndStructure
  
  ;------------------------------------------------------------------------------------------------
  ; Get number items in ListIcon
  ;------------------------------------------------------------------------------------------------
  
  NumberOfItems.i = CountGadgetItems(#Gadget_RashadBin_FileList)
  
  ;------------------------------------------------------------------------------------------------
  ; Get number items in ListIcon
  ;------------------------------------------------------------------------------------------------
  
  If NumberOfItems.i  <> #NoListItems
    
    ;----------------------------------------------------------------------------------------------
    ; Get number items in ListIcon
    ;----------------------------------------------------------------------------------------------
    
    NewList Resource.ResourceData()
    
    ;----------------------------------------------------------------------------------------------
    ; Place each item text into the list. Must start at Zero
    ;----------------------------------------------------------------------------------------------
    
    For LoopCounter.i = 0 To NumberOfItems.i - 1
      
      AddElement(Resource())
      
      Resource()\CurrentResourceName      = GetGadgetItemText(#Gadget_RashadBin_FileList, LoopCounter.i, 0)
      
      Resource()\CurrentResourceType      = GetGadgetItemText(#Gadget_RashadBin_FileList, LoopCounter.i, 1)
      
      Resource()\CurrentResourceDirectory = GetGadgetItemText(#Gadget_RashadBin_FileList, LoopCounter.i, 2)
      
    Next LoopCounter 
    
    ;----------------------------------------------------------------------------------------------
    ; Sort the Array in ascending order
    ;----------------------------------------------------------------------------------------------
    
    SortStructuredList(Resource(), #PB_Sort_Ascending, OffsetOf(ResourceData\CurrentResourceName), #PB_String)
    
    ;----------------------------------------------------------------------------------------------
    ; Now replace ListIcon Items from the sorted Array
    ;----------------------------------------------------------------------------------------------
    
    ForEach Resource()
      
      SetGadgetItemText(#Gadget_RashadBin_FileList, ListIndex(Resource()), Resource()\CurrentResourceName,      0)
      
      SetGadgetItemText(#Gadget_RashadBin_FileList, ListIndex(Resource()), Resource()\CurrentResourceType,      1)
      
      SetGadgetItemText(#Gadget_RashadBin_FileList, ListIndex(Resource()), Resource()\CurrentResourceDirectory, 2)
      
    Next Resource()
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    ClearList(Resource())
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

EndProcedure

; IDE Options = PureBasic 5.61 (Windows - x86)
; CursorPosition = 1
; FirstLine = 12
; Folding = -
; EnableAsm
; EnableXP
; EnableUnicode