﻿;==============================================================================================================================================================================
; 
;==============================================================================================================================================================================

XIncludeFile "RashadBin_Constants.pb"                                                                ; Visual designer created constants file
XIncludeFile "RashadBin_Windows.pb"                                                                  ; Visual designer created window code
XIncludeFile "RashadBin_Mydeclarations.pb"                                                           ; My own procedural declarations
XIncludeFile "RashadBin_Myconstants.pb"                                                              ; My own added on constants

;==============================================================================================================================================================================
; Generic modules
;==============================================================================================================================================================================

XIncludeFile  "Modules\Thirdparty\_MakeValidName.pbi"                                                ; TS-Soft, create valid label for datasection use

;==============================================================================================================================================================================
; Generic modules
;==============================================================================================================================================================================

XIncludeFile  "Modules\Generic\_AdjustSpinGadget.pbi"                                                ; Adjust the spingadget up or down (I like to keep event handler section clean and readable)
XIncludeFile  "Modules\Generic\_GetLastErrorString.pbi"                                              ; Get the last error as a readable string
XIncludeFile  "Modules\Generic\_MakeSureDirectoryPathExists.pbi"                                     ; Unicode aware directory creation

;==============================================================================================================================================================================
; Custom modules
;==============================================================================================================================================================================

XIncludeFile  "Modules\Custom\_RemoveGadgetBorders.pbi"                                              ; Remove borders from various gadgets
XIncludeFile  "Modules\Custom\_SaveLastUsedFileSemaphore.pbi"                                        ; Keep track of the last used resource file for automatic reloading
XIncludeFile  "Modules\Custom\_SaveCurrentErrorLog.pbi"                                              ; Save the current list of errors to a dated log file
XIncludeFile  "Modules\Custom\_SetFileTreeAllowedType.pbi"                                           ; Set the ExplorerTreeGadget to the allowed filetypes and update the ExplorerList
XIncludeFile  "Modules\Custom\_SetInfoBarArea.pbi"                                                   ; Send messages and error reports to the fake status bar area
XIncludeFile  "Modules\Custom\_TagAllFiles.pbi"                                                      ; Tag all files in the currently active gadget
XIncludeFile  "Modules\Custom\_TitleBarClock.pbi"                                                    ; Run an asynchronous clock in the window title bar

;==============================================================================================================================================================================
; Ininitialisation file handling
;==============================================================================================================================================================================

;XIncludeFile  "Modules\Preferences\_CreatePreferencesFile.pbi"                                        ; Create a new preferences file
;XIncludeFile  "Modules\Preferences\_ReadPreferencesFile.pbi"                                          ; Read an existing preferences file
;XIncludeFile  "Modules\Preferences\_SavePreferencesFile.pbi"                                          ; Save the preferences file

;==============================================================================================================================================================================
; Handling datasection files
;==============================================================================================================================================================================

XIncludeFile  "Modules\Datasection\_SaveToCurrentDataSectionFile.pbi"                                ; Write all selected resources to the PB DataSection file
XIncludeFile  "Modules\Datasection\_SetNewDataSectionFile.pbi"                                       ; Select a new DataSection file to write to

;==============================================================================================================================================================================
; Handling directory list files
;==============================================================================================================================================================================

XIncludeFile  "Modules\Filelist\_AddSingleFileToFileList.pbi"                                        ; Double click adding a single resource to the list
XIncludeFile  "Modules\Filelist\_GetFileListItemDetails.pbi"                                         ; Update filelist tracking details
XIncludeFile  "Modules\Filelist\_ShowFilesFromDirectoryTree.pbi"                                     ; Show files in the filelist when a directory is clicked on

;==============================================================================================================================================================================
; Handling resource list files
;==============================================================================================================================================================================

XIncludeFile  "Modules\Resource\_ClearResourceFileList.pbi"                                          ; Clear all files from the resources list
XIncludeFile  "Modules\Resource\_DeleteFromResourceFileList.pbi"                                     ; Double click to delete a file from the resources list
XIncludeFile  "Modules\Resource\_GetResourceListItemDetails.pbi"                                     ; Update resourcelist tracking details
XIncludeFile  "Modules\Resource\_LoadResourceFileList.pbi"                                           ; Load another resource list
XIncludeFile  "Modules\Resource\_ImportResourcesFromDisk.pbi"                                        ; Manually import resources from disk with a filerequester
XIncludeFile  "Modules\Resource\_SaveResourceFileList.pbi"                                           ; Save the current list of resources to disk
XIncludeFile  "Modules\Resource\_SetNewResourceFileList.pbi"                                         ; Set a new resource file list to save to
XIncludeFile  "Modules\Resource\_SortResourceListEntries.pbi"                                        ; Alphabetically sort the list of resources after it was added to

;==============================================================================================================================================================================
; Drag and drop handlers
;==============================================================================================================================================================================

XIncludeFile  "Modules\Draganddrop\_DragToResourceFileList.pbi"                                      ; Start dragging selected resources to the resource list
XIncludeFile  "Modules\Draganddrop\_DropOnResourceFileList.pbi"                                      ; Drop and display the dragged resources onto the resource list

;==============================================================================================================================================================================
; Main Loop
;==============================================================================================================================================================================

If Window_RashadBin()

  ;------------------------------------------------------------------------------------------------
  ; Create your program directories
  ;------------------------------------------------------------------------------------------------
  
  MakeSureDirectoryPathExists(Program\SavedIncludesDirectory)                                          ; All generated datasection files
  MakeSureDirectoryPathExists(Program\ResourceListDirectory)                                           ; Saved lists of resource files 
  MakeSureDirectoryPathExists(Program\ConfigDirectory.s)                                               ; Configuration files
  MakeSureDirectoryPathExists(Program\ErrorDirectory.s)                                                ; Error logs

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Program\QuitValue = #False
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  AddKeyboardShortcut(#Window_RashadBin, #PB_Shortcut_Alt | #PB_Shortcut_X, #RashadBin_Exit)
  
  AddKeyboardShortcut(#Window_RashadBin, #PB_Shortcut_Alt | #PB_Shortcut_T, #TagAllFiles)
  
  ;------------------------------------------------------------------------------------------------
  ; Create the permanent title bar clock timer
  ;------------------------------------------------------------------------------------------------

  SetTimer_(WindowID(#Window_RashadBin), #TitleBarClockTimerEvent, 1000, @TitleBarClock())    ; 1000 = 1 second
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ; SetGadgetAttribute(#Gadget_RashadBin_FileTree, #PB_Explorer_DisplayMode, #PB_Explorer_LargeIcon)
  
  ; SetGadgetAttribute(#Gadget_RashadBin_FileList, #PB_ListIcon_DisplayMode, #PB_ListIcon_LargeIcon)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ; RemoveBorders(#Gadget_RashadBin_FileList)
  
  ;------------------------------------------------------------------------------------------------
  ; Enable resource adding by drag and drop
  ;------------------------------------------------------------------------------------------------
  
  EnableGadgetDrop(#Gadget_RashadBin_FileList, #PB_Drop_Text,   #PB_Drag_Copy)
  
  EnableGadgetDrop(#Gadget_RashadBin_FileList, #PB_Drop_Files,  #PB_Drag_Copy)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ;SplitterGadget(#ExplorerListSplitter, 440, 5, 135, 545, #Gadget_RashadBin_FileTree, #Gadget_RashadBin_FileList, #PB_Splitter_Separator)
  
  ;SetGadgetState(#ExplorerListSplitter, 450)
  
  ;GadgetToolTip(#ExplorerListSplitter,  "Pull me up or down to show more of either pane.")
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  SetGadgetState(#Gadget_RashadBin_sColumnsPerLine, 5)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  AddGadgetItem(#Gadget_RashadBin_cAllowedfiletypes, #AtTheEndOfTheList, "*.*")
  
  AddGadgetItem(#Gadget_RashadBin_cAllowedfiletypes, #AtTheEndOfTheList, "*.Png")
  
  AddGadgetItem(#Gadget_RashadBin_cAllowedfiletypes, #AtTheEndOfTheList, "*.Jpg")
  
  AddGadgetItem(#Gadget_RashadBin_cAllowedfiletypes, #AtTheEndOfTheList, "*.Tif")
  
  AddGadgetItem(#Gadget_RashadBin_cAllowedfiletypes, #AtTheEndOfTheList, "*.Bmp")
  
  AddGadgetItem(#Gadget_RashadBin_cAllowedfiletypes, #AtTheEndOfTheList, "*.Tga")
  
  AddGadgetItem(#Gadget_RashadBin_cAllowedfiletypes, #AtTheEndOfTheList, "*.Ico")
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  SetGadgetState(#Gadget_RashadBin_cAllowedfiletypes, #FirstItem)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  DirectoryTree\CurrentFileTypes = GetGadgetText(#Gadget_RashadBin_cAllowedfiletypes)
  
  DirectoryTree\CurrentDirectory = Program\CurrentDirectory  + "Images\_Other\"
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  SetGadgetText(#Gadget_RashadBin_DirectoryTree, Program\CurrentDirectory  + "Images\_Other\")
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  SetGadgetText(#Gadget_RashadBin_sCurrentresourcelist, "Default resources list.pbrsc")
  
  SetGadgetText(#Gadget_RashadBin_sCurrentdatafile,     "Default datasection.pbi")
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  LoadResourceFileList("Old")
  
  ;------------------------------------------------------------------------------------------------
  ; Set the fake statusbar heading appropriate for the run time of the program
  ;------------------------------------------------------------------------------------------------
  
  SetInfoBarArea("Headings",  "Welcome", #Fish + "Welcome to " + #Basename + #Version + Program\CompileCounters  + ", Have a nice Day (Beware the fish!)")
  
  SetInfoBarArea("Resources", #EmptyString, "0")
  
  SetInfoBarArea("Images",    #EmptyString, "0")
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  PostEvent(#PB_Event_Gadget, #Window_RashadBin, #Gadget_RashadBin_DirectoryTree, #PB_EventType_Change)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Repeat
    
    ;--------------------------------------------------
    ; 
    ;--------------------------------------------------
    
    EventID  = WaitWindowEvent()
    MenuID   = EventMenu()
    GadgetID = EventGadget()
    WindowID = EventWindow()
    
    ;--------------------------------------------------
    ; 
    ;--------------------------------------------------
    
    Select EventID
        
      ;------------------------------------------------
      ; 
      ;------------------------------------------------
        
      Case #PB_Event_CloseWindow
        Select WindowID
          Case #Window_RashadBin                      : Program\QuitValue = #True
        EndSelect
        
        ;----------------------------------------------
        ; Drag and drop items between locations
        ;----------------------------------------------
        
      Case #PB_Event_GadgetDrop
        Select EventDropType()
          Case #PB_Drop_Text
            Select GadgetID
              Case #Gadget_RashadBin_FileList         : DropOnResourceFilelist("Text")
            EndSelect
          Case #PB_Drop_Files
            Select GadgetID
              Case #Gadget_RashadBin_FileList         : DropOnResourceFilelist("Files")
            EndSelect
        EndSelect
        
        ;----------------------------------------------
        ; 
        ;----------------------------------------------
        
      Case #PB_Event_Menu
        Select MenuID
          Case #MenuBar_RashadBin_Newdatafile         : SetNewDatasectionFile()
          Case #MenuBar_RashadBin_Savedatafile        : SaveToCurrentDatasectionFile()
          Case #MenuBar_RashadBin_Exitprogram         : Program\QuitValue = #True
          Case #MenuBar_RashadBin_Newlist             : SetNewResourceFileList()
          Case #MenuBar_RashadBin_Savelist            : SaveResourceFileList("New")
          Case #MenuBar_RashadBin_Loadlist            : LoadResourceFileList("New")
          Case #MenuBar_RashadBin_Clearlist           : ClearResourceFileList()
          Case #MenuBar_RashadBin_Importresources     : ImportResourcesFromDisk()
          Case #MenuBar_RashadBin_Showhelp            : ; ShowHelp()
            
          Case #RashadBin_Exit                        : Program\QuitValue = #True
            
          Case #TagAllFiles                           : TagAllFiles()
        EndSelect
        
        ;----------------------------------------------
        ; 
        ;----------------------------------------------
        
      Case #PB_Event_Gadget
        Select GadgetID
          Case #Gadget_RashadBin_DirectoryTree
            Select EventType()
              Case #PB_EventType_LeftClick            : ShowFilesFromDirectoryTree()  ; Show all specifed file types for the current directory
              Case #PB_EventType_Change               : ShowFilesFromDirectoryTree()  ; Show all specifed file types for the current directory
            EndSelect
            
            ;------------------------------------------
            ; 
            ;------------------------------------------
            
          Case #Gadget_RashadBin_FileTree
            Select EventType()
              Case #PB_EventType_LeftClick            : GetFileListItemDetails()      ; Get current line, file and directory name from the file list
              Case #PB_EventType_LeftDoubleClick      : AddSingleFileToFileList()     ; Double click to add a single resource to the list
              Case #PB_EventType_DragStart            : DragToResourceFileList()      ; Drag multiple resources to the list
            EndSelect
            
            ;------------------------------------------
            ; 
            ;------------------------------------------
            
          Case #Gadget_RashadBin_FileList
            Select EventType()
              Case #PB_EventType_LeftClick            : GetResourceListItemDetails()  ; Get current line, file and directory name from the resource list
              Case #PB_EventType_LeftDoubleClick      : DeleteFromResourceFileList()  ; Delete a single resource from the list
            EndSelect
            
            ;------------------------------------------
            ; 
            ;------------------------------------------
            
          Case #Gadget_RashadBin_bNewdatafile         : SetNewDatasectionFile()       ; Setup a new datasection file name
          Case #Gadget_RashadBin_bSavedatafile        : SaveToCurrentDatasectionFile(); Save all resources to the current datasection file name
            
          ;--------------------------------------------
          ; 
          ;--------------------------------------------
            
          Case #Gadget_RashadBin_bClearcurrentlist    : ClearResourceFileList()       ; Clear all resources from the list
          Case #Gadget_RashadBin_bLoadlistfromfile    : LoadResourceFileList("New")   ; Load a different resource list other than the default one
          Case #Gadget_RashadBin_bWritelisttofile     : SaveResourceFileList("New")   ; Save a different resource list other than the default one
          Case #Gadget_RashadBin_bNewResourceFile     : SetNewResourceFileList()      ; Set a new resource file list name
            
          ;--------------------------------------------
          ; 
          ;--------------------------------------------
            
          Case #Gadget_RashadBin_bExithisprogram      : Program\QuitValue = #True     ; Quit the program immediately
            
          ;--------------------------------------------
          ; 
          ;--------------------------------------------
            
          Case #Gadget_RashadBin_sColumnsPerLine      : AdjustSpinGadget(#Gadget_RashadBin_sColumnsPerLine)
          Case #Gadget_RashadBin_cAllowedfiletypes    : SetFileTreeAllowedType()
            
          ;--------------------------------------------
          ; 
          ;--------------------------------------------
            
        EndSelect
        
        ;----------------------------------------------
        ; 
        ;----------------------------------------------
        
    EndSelect
    
    ;--------------------------------------------------
    ; 
    ;--------------------------------------------------
    
  Until Program\QuitValue
  
  ;----------------------------------------------------
  ; 
  ;----------------------------------------------------
  
  SaveResourceFileList("Old")
  
  ;----------------------------------------------------
  ; 
  ;----------------------------------------------------
  
  SaveCurrentErrorLog()
  
  ;----------------------------------------------------
  ; 
  ;----------------------------------------------------
  
  SaveLastUsedFileSemaphore()
  
  ;----------------------------------------------------
  ; 
  ;----------------------------------------------------
  
  CloseWindow(#Window_RashadBin)
  
  ;----------------------------------------------------
  ; 
  ;----------------------------------------------------
  
EndIf

;------------------------------------------------------
; 
;------------------------------------------------------

End


; IDE Options = PureBasic 5.61 (Windows - x86)
; CursorPosition = 15
; EnableAsm
; EnableXP
; DisableDebugger
; EnableCompileCount = 145
; EnableBuildCount = 0
; EnableExeConstant
; EnableUnicode