﻿;==============================================================================================================================================================================
; Need a unicode aware version of the API directory creator for database directory, temporary directory and maybe others
;==============================================================================================================================================================================

Import "shell32.lib"                                                                                 ; Import 32 bit shell library
  SHCreateDirectory(*hwnd, pszPath.p-unicode)                                                         ; Grab the function that you want
EndImport                                                                                            ; End function import

;==========================================================================================================================================================
; 
;==========================================================================================================================================================

UseJPEG2000ImageDecoder()                                                                             ; 
UseJPEGImageDecoder()                                                                                 ; 
UsePNGImageDecoder()                                                                                  ; 
UseTGAImageDecoder()                                                                                  ; 
UseTIFFImageDecoder()                                                                                 ; 

;==========================================================================================================================================================
; 
;==========================================================================================================================================================

#AtTheEndOfTheList = -1                                                                               ; 

#EmptyString       = ""                                                                               ; 
#StringNotFound    = 0                                                                                ; 

#NoFileHandle      = 0                                                                                ; 
#NotFileEnd        = 0                                                                                ; 
#NoCurrentLine     = -1                                                                               ; 

#NoListItems       = 0                                                                                ; 
#FirstItem         = 0                                                                                ; 

#Fish                           = "<°)))o><²³  "                                                      ; Beware the fish!!

#TitleBarClockTimerEvent        = 624                                                                 ; Title bar clock timer event

;==========================================================================================================================================================
; 
;==========================================================================================================================================================

#NameColumn       = 0                                                                                 ; 
#TypeColumn       = 1                                                                                 ; 
#DirectoryColumn  = 2                                                                                 ; 

;==============================================================================================================================================================================
; My personal constants
;==============================================================================================================================================================================

#Author                         = "Miklós G Bolváry, "                                                ; Author's name
#CopyRight                      = "MGB Technical Services 2017 "                                      ; Copyright holder
#Basename                       = "RashadBIN "                                                        ; Base name for initialisation file and database
#Version                        = "v0.00."                                                            ; Program version
#Program                        = #Basename + #Version                                                ; Copyright string
#SystrayNote                    = "Hello, " + #Program + " is hiding here"                            ; System tray note

;==========================================================================================================================================================
; 
;==========================================================================================================================================================

Structure ProgramData
  QuitValue.i                                                                                        ; Program quit flag
  
  Currentdirectory.s                                                                                 ; Current directory string
  CurrentDataSectionFile.i                                                                           ; Currently open datasection file handle
  CurrentDataSectionFileName.s                                                                       ; Currently open datasection file name
  
  ConfigDirectory.s                                                                                  ; Configuration files
  
  ErrorDirectory.s                                                                                   ; Directory of the error messages file
  
  SavedIncludesDirectory.s                                                                           ; All generated datasection files
  ResourceListDirectory.s                                                                            ; Saved lists of resource files
  
  ; Compiler and build counts
  
  CompileCounters.s                                                                                  ; Compiler and build counter
  
  TimeOffset.i                                                                                       ; Time zone offset, used for UTC calculations
EndStructure

;==========================================================================================================================================================
; 
;==========================================================================================================================================================

Structure TreeDirectoryData                                                                         ; 
  CurrentLine.i                                                                                      ; 
  CurrentDirectory.s                                                                                 ; 
  CurrentFileTypes.s                                                                                 ; File types to display
EndStructure                                                                                        ; 

;==========================================================================================================================================================
; 
;==========================================================================================================================================================

Structure FileListData                                                                              ; 
  CurrentLine.i                                                                                      ; 
  CurrentFile.s                                                                                      ; 
  CurrentType.s                                                                                      ; 
  CurrentDirectory.s                                                                                 ; 
EndStructure                                                                                        ; 

;==========================================================================================================================================================
; 
;==========================================================================================================================================================

Structure ResourceListData                                                                          ; 
  CurrentLine.i                                                                                      ; 
  CurrentFile.s                                                                                      ; 
  CurrentType.s                                                                                      ; 
  CurrentDirectory.s                                                                                 ; 
EndStructure                                                                                        ; 

;==========================================================================================================================================================
; 
;==========================================================================================================================================================

Global  Program.ProgramData                                                                         ; 
Global  DirectoryTree.TreeDirectoryData                                                             ; 
Global  FileList.FileListData                                                                       ; 
Global  ResourceList.ResourceListData                                                               ; 

;==========================================================================================================================================================
; 
;==========================================================================================================================================================

Program\CurrentDirectory          = GetCurrentDirectory()                                            ; 

Program\SavedIncludesDirectory.s  = Program\CurrentDirectory  + "Store\Datasections\"                ; 
Program\ResourceListDirectory.s   = Program\CurrentDirectory  + "Store\Resourcelists\"               ; 

Program\ConfigDirectory.s         = Program\CurrentDirectory  + "Store\Configuration\"               ; Configuration files

Program\ErrorDirectory.s          = Program\CurrentDirectory  + "Store\Errorlogs\"                   ; Error logs

; ;==============================================================================================================================================================================
; ; Create your program directories
; ;==============================================================================================================================================================================
; 
; MakeSureDirectoryPathExists(Program\SavedIncludesDirectory)                                          ; All generated datasection files
; MakeSureDirectoryPathExists(Program\ResourceListDirectory)                                           ; Saved lists of resource files 
; MakeSureDirectoryPathExists(Program\ConfigDirectory.s)                                               ; Configuration files
; MakeSureDirectoryPathExists(Program\ErrorDirectory.s)                                                ; Error logs

;==============================================================================================================================================================================
; Create your program directories
;==============================================================================================================================================================================

Program\CompileCounters     = Str(#PB_Editor_CompileCount) + "." + Str(#PB_Editor_BuildCount) + "a"  ; Add to program version

;==============================================================================================================================================================================
; Get time zone information used for UTC calculations (Baldrick)
;==============================================================================================================================================================================

#MinutesPerHour = 60

Select GetTimeZoneInformation_(Tz.Time_zone_information) 
  Case #TIME_ZONE_ID_INVALID   : MessageRequester("Time Zone error", "Your Windows time zone id appears to be invalid?.", #PB_MessageRequester_Ok)
  Case #TIME_ZONE_ID_UNKNOWN   : MessageRequester("Time Zone error", "Your Windows time zone id appears to be invalid?.", #PB_MessageRequester_Ok)
  Case #TIME_ZONE_ID_STANDARD  : Program\TimeOffset = (Tz\Bias + Tz\StandardBias)
  Case #TIME_ZONE_ID_DAYLIGHT  : Program\TimeOffset = (Tz\Bias + Tz\DaylightBias)
EndSelect

;==============================================================================================================================================================================
; Setup day and month literal names
;==============================================================================================================================================================================

Define DaysPerMonthFill.i                                                                             ; 

Global Dim NameOfDay.s(7)                                                                             ; Fill an array with the names of the days (Terry Hough I think)

  NameOfDay(0)      = "Sunday"
  NameOfDay(1)      = "Monday"
  NameOfDay(2)      = "Tuesday"
  NameOfDay(3)      = "Wednesday"
  NameOfDay(4)      = "Thursday"
  NameOfDay(5)      = "Friday"
  NameOfDay(6)      = "Saturday"

Global Dim DaysPerMonth(12)                                                                           ; Fill an array on how many days per month there are

  For DaysPerMonthFill.i = 0 To 11     
    DaysPerMonth(DaysPerMonthFill.i) = 31 
  Next

  DaysPerMonth(1)   = 28
  DaysPerMonth(3)   = 30
  DaysPerMonth(5)   = 30
  DaysPerMonth(8)   = 30
  DaysPerMonth(10)  = 30

Global Dim NameOfMonth.s(12)                                                                          ; Fill an array with the names of the months

  NameOfMonth(0)    = "January"
  NameOfMonth(1)    = "February"
  NameOfMonth(2)    = "March"
  NameOfMonth(3)    = "April"
  NameOfMonth(4)    = "May"
  NameOfMonth(5)    = "June"
  NameOfMonth(6)    = "July"
  NameOfMonth(7)    = "August"
  NameOfMonth(8)    = "September"
  NameOfMonth(9)    = "October"
  NameOfMonth(10)   = "November"
  NameOfMonth(11)   = "December"

Global Dim Years.s(19)                                                                                ; Fill an array with the years

  Years(0)          = "2002"
  Years(1)          = "2003"
  Years(2)          = "2004"
  Years(3)          = "2005"
  Years(4)          = "2006" 
  Years(5)          = "2007"
  Years(6)          = "2008"
  Years(7)          = "2009"
  Years(8)          = "2010"
  Years(9)          = "2011"
  Years(10)         = "2012"
  Years(11)         = "2013"
  Years(12)         = "2014"
  Years(13)         = "2015"
  Years(14)         = "2016"
  Years(15)         = "2017"
  Years(16)         = "2018"
  Years(17)         = "2019"
  Years(18)         = "2020"

;==============================================================================================================================================================================
; Gadget enumerations
;==============================================================================================================================================================================

Enumeration #GadgetIndex
  ; Other gadgets
  #ExplorerListSplitter                                                                              ; 
  
  ; Keyboard shortcuts
  #RashadBin_Exit                                                                                    ; 
  
  #TagAllFiles                                                                                       ; 
EndEnumeration


; IDE Options = PureBasic 5.61 (Windows - x86)
; CursorPosition = 7
; EnableXP