﻿;==============================================================================================================================================================================
; Generic modules
;==============================================================================================================================================================================

Declare.s MakeValidName(Labelname.s)                                                                  ; TS-Soft, create valid label for datasection use

;==========================================================================================================================================================
; Generic modules
;==========================================================================================================================================================

Declare   AdjustSpinGadget(Gadget.i)                                                                  ; Adjust the spingadget up or down (I like to keep event handler section clean and readable)
Declare.s GetLastErrorString(Error.i = 0)                                                             ; Get the last windows error and return the error string
Declare.s MakeSureDirectoryPathExists(Directory.s)                                                    ; Unicode aware directory creation

;==========================================================================================================================================================
; Custom modules
;==========================================================================================================================================================

Declare   RemoveGadgetBorders(GadgetConstant.i)                                                       ; Remove borders from various gadgets
Declare   SaveLastUsedFileSemaphore()                                                                 ; Keep track of the last used resource file for automatic reloading
Declare   SaveCurrentErrorLog()                                                                       ; Save the current list of errors to a dated log file
Declare   SetFileTreeAllowedType()                                                                    ; Set the ExplorerTreeGadget to the allowed filetypes and update the ExplorerList
Declare   SetInfoBarArea(FieldName.s, FieldStatus.s, MessageContent.s = "0", ModuleName.s = "")       ; Send messages and error reports to the fake status bar area
Declare   TagAllFiles()                                                                               ; Tag all files in the currently active gadget
Declare   TitleBarClock(ObjectHandle.i, Message.i, EventNumber.i, TimePeriod.i)                       ; Run an asynchronous clock in the window title bar

;==========================================================================================================================================================
; Ininitialisation file handling
;==========================================================================================================================================================

;Declare   CreatePreferencesFile()                                                                     ; Create a new preferences file
;Declare   ReadPreferencesFile()                                                                       ; Read an existing preferences file
;Declare   SavePreferencesFile()                                                                       ; Save the preferences file

;==========================================================================================================================================================
; Handling datasection files
;==========================================================================================================================================================

Declare   SetNewDataSectionFile()                                                                     ; Write all selected resources to the PB DataSection file
Declare   Savetocurrentdatasectionfile()                                                              ; Select a new DataSection file to write to

;==============================================================================================================================================================================
; Handling directory list files
;==============================================================================================================================================================================

Declare   AddSingleFileToFileList()                                                                   ; Double click adding a single resource to the list
Declare   GetFileListItemDetails()                                                                    ; Update filelist tracking details
Declare   ShowFilesFromDirectoryTree()                                                                ; Show files in the filelist when a directory is clicked on

;==========================================================================================================================================================
; Handling resource list files
;==========================================================================================================================================================

Declare   ClearResourceFileList()                                                                     ; Clear all files from the resources list
Declare   DeleteFromResourceFileList()                                                                ; Double click to delete a file from the resources list
Declare   GetResourceListItemDetails()                                                                ; Update resourcelist tracking details
Declare   ImportResourcesFromDisk()                                                                   ; Load another resource list
Declare   LoadResourceFileList(Mode.s)                                                                ; Manually import resources from disk with a filerequester 
Declare   SaveResourceFileList(Mode.s)                                                                ; Save the current list of resources to disk
Declare   SetNewResourceFileList()                                                                    ; Set a new resource file list to save to
Declare   SortResourceListEntries()                                                                   ; Alphabetically sort the list of resources after it was added to

;==============================================================================================================================================================================
; Drag and drop handlers
;==============================================================================================================================================================================

Declare   DragToResourceFileList()                                                                    ; Start dragging selected resources to the resource list
Declare   DropOnResourceFileList(DragType.s)                                                          ; Drop and display the dragged resources onto the resource list

;==============================================================================================================================================================================
; 
;==============================================================================================================================================================================


; IDE Options = PureBasic 5.61 (Windows - x86)
; CursorPosition = 4
; EnableXP